import Foundation
import ApolloUtils

/// Provides the format to convert a [GraphQL Interface](https://spec.graphql.org/draft/#sec-Interfaces)
/// into Swift code.
struct InterfaceTemplate: TemplateRenderer {
  /// IR representation of source [GraphQL Interface](https://spec.graphql.org/draft/#sec-Interfaces).
  let graphqlInterface: GraphQLInterfaceType

  let config: ApolloCodegen.ConfigurationContext

  let target: TemplateTarget = .schemaFile

  var template: TemplateString {
    """
    \(documentation: graphqlInterface.documentation, config: config)
    \(embeddedAccessControlModifier)\
    final class \(graphqlInterface.name.firstUppercased): Interface { }

    """
  }
}
